<?php

/**
 * Custom blocks
 *
 * @package CustomBlocks
 * @version 2.1
 * @author davidhs
 * @copyright 2013 by davidhs
 * @license Creative Commons Attribution 3.0 Unported License http://creativecommons.org/licenses/by/3.0/
 */

// Template for admin area settings (edit).
function template_cb_settings_edit()
{
	global $txt, $scripturl, $context, $settings;

	echo '
	<form action="', $scripturl, '?action=featuresettings;sa=cbedit;pos=', $context['pos'], ';id=', $context['id'], $context['params_url'], ';sesc=', $context['session_id'], '" method="post" accept-charset="', $context['character_set'], '">
		<table width="80%" border="0" cellspacing="0" cellpadding="0" class="tborder" align="center">
			<tr><td>
				<table border="0" cellspacing="0" cellpadding="4" width="100%">
					<tr class="titlebg">
						<td colspan="3">', $context['settings_title'], '</td>
					</tr>
					<tr class="windowbg2">
						<td class="windowbg2"></td>
						<td valign="top">
							<label for="description">', $txt['cb_description'], '</label>
						</td>
						<td class="windowbg2" width="50%">
							<textarea name="description" id="description" rows="2" cols="30">', $context['params']['description'], '</textarea>
						</td>
					</tr>
					<tr class="windowbg2">
						<td class="windowbg2"></td>
						<td valign="top">
							<label for="cb_frame">', $txt['cb_frame'], '</label><br />
							<span class="smalltext">', $txt['cb_frame_desc'], '</span>
						</td>
						<td class="windowbg2" width="50%">
							<textarea name="frame" id="cb_frame" rows="4" cols="30">', $context['params']['frame'], '</textarea>
						</td>
					</tr>
					<tr class="windowbg2">
						<td class="windowbg2"></td>
						<td valign="top">
							<label for="type">', $txt['cb_type'], '</label>
						</td>
						<td class="windowbg2" width="50%">
							<select name="type" id="type">';

	foreach ($context['params']['type_array'] as $k => $v)
		echo '
								<option value="', $k, '"', $context['params']['type'] == $k ? ' selected="selected"' : '', '>', $v, '</option>';

	echo '
							</select>
						</td>
					</tr>
					<tr class="windowbg2">
						<td class="windowbg2" valign="top" width="16"><a href="', $scripturl, '?action=helpadmin;help=cb_content" onclick="return reqWin(this.href);" class="help"><img src="', $settings['images_url'], '/helptopics.gif" alt="', $txt[119], '" border="0" align="top" /></a></td>
						<td valign="top">
							<label for="content">', $txt['cb_content'], '</label>', 'footer' == $context['pos'] ? '<br />
							<span class="smalltext">' . $txt['cb_content_footer_desc'] . '</span>' : '','
						</td>
						<td class="windowbg2" width="50%">
							<textarea name="content" id="content" rows="4" cols="30">', $context['params']['content'], '</textarea>
						</td>
					</tr>
					<tr class="windowbg2">
						<td class="windowbg2"></td>
						<td valign="top">
							<label for="order">', $txt['cb_order'], '</label>
						</td>
						<td class="windowbg2" width="50%">
							<input type="text" name="order" id="order" value="', $context['params']['order'], '" size="5" />
						</td>
					</tr>
					<tr class="windowbg2">
						<td class="windowbg2"></td>
						<td valign="top">
							', $txt['cb_permissions'], '<br />
							<span class="smalltext">', $txt['cb_permissions_desc'], '</span>
						</td>
						<td class="windowbg2" width="50%">
							<table>
								<tr>
									<td>&nbsp;</td>';
	foreach ($context['params']['permissions_actions'] as $pa => $txt_pa)
		echo '
									<td align="center">', $txt_pa, '</td>';
	echo '
								</tr>';
	foreach ($context['params']['permissions_users'] as $pu => $txt_pu)
	{
		echo '
								<tr>
									<td align="left">', $txt_pu, '</td>';
		foreach ($context['params']['permissions_actions'] as $pa => $txt_pa)
		{
			$perm = $pu . ':' . $pa;
			echo '
									<td align="center"><input type="checkbox" name="permissions[]" value="' . $perm . '"' . (in_array($perm, $context['params']['permissions']) ? ' checked="checked"' : '') . ' class="check" />', '</td>';
		}
		echo '
								</tr>';
	}
	echo '
							</table>
						</td>
					</tr>
					<tr class="windowbg2">
						<td class="windowbg2"></td>
						<td valign="top">
							<label for="active">', $txt['cb_active'], '</label><br />
							<span class="smalltext">', $txt['cb_active_desc'], '</span>
						</td>
						<td class="windowbg2" width="50%">
							<input type="checkbox" name="active" id="active" value="1"', $context['params']['active'] ? ' checked="checked"' : '', ' class="check" />
						</td>
					</tr>
					</tr><tr>
						<td class="windowbg2" colspan="3" align="center" valign="middle"><input type="submit" name="save" value="', $txt[10], '" /></td>
					</tr>
				</table>
			</td></tr>
		</table>
	</form>';
}

// Template for admin area settings (show).
function template_cb_settings_show()
{
	global $txt, $scripturl, $context, $settings;

	echo '
	<table width="100%" border="0" cellspacing="0" cellpadding="0" class="tborder" align="center">
		<tr><td>
			<table border="0" cellspacing="0" cellpadding="4" width="100%">
				<tr class="titlebg">
					<td valign="top" width="16"><a href="', $scripturl, '?action=helpadmin;help=cb" onclick="return reqWin(this.href);" class="help"><img src="', $settings['images_url'], '/helptopics.gif" alt="', $txt[119], '" border="0" align="top" /></a></td>
					<td>', $context['settings_title'], '</td>
				</tr>
				<tr class="windowbg2">
					<td colspan="2" class="windowbg2">';

	$pos_array = array('header_above', 'header', 'header_below', 'footer_above', 'footer', 'footer_below');
	foreach ($pos_array as $i => $pos)
	{
		if (!$i)
			echo '
						<br />';
		template_cb_show_list('cb_settings_show_' . $pos);
	}

	echo '
					</td>
				</tr>
			</table>
		</td></tr>
	</table>';
}

// Shows list.
function template_cb_show_list($list_id = null)
{
	global $context, $settings, $txt;

	// Get a shortcut to the current list.
	$list_id = $list_id === null ? $context['default_list'] : $list_id;
	$cur_list = &$context[$list_id];
	$col_count = count($cur_list['headers']);

	// These are the main tabs that is used all around the template.
	if (!empty($settings['use_tabs']) && isset($cur_list['list_menu'], $cur_list['list_menu']['show_on']) && ($cur_list['list_menu']['show_on'] == 'both' || $cur_list['list_menu']['show_on'] == 'top'))
		template_cb_create_list_menu($cur_list['list_menu'], 'top');

	if (isset($cur_list['form']))
		echo '
	<form action="', $cur_list['form']['href'], '" method="post"', empty($cur_list['form']['name']) ? '' : ' name="' . $cur_list['form']['name'] . '" id="' . $cur_list['form']['name'] . '"', ' accept-charset="', $context['character_set'], '">';

	echo '
		<table border="0" cellspacing="1" cellpadding="4" align="center" width="100%" class="bordercolor">';

	// Show the title of the table (if any).
	if (!empty($cur_list['title']))
	{
		echo '
			<tr class="catbg">
				<td align="left" colspan="', $cur_list['num_columns'], '">
					', $cur_list['title'], '
				</td>
			</tr>';
	}

	// This is for the old style menu with the arrows "> Test | Test 1".
	if (empty($settings['use_tabs']) && isset($cur_list['list_menu'], $cur_list['list_menu']['show_on']) && ($cur_list['list_menu']['show_on'] == 'both' || $cur_list['list_menu']['show_on'] == 'top'))
		template_cb_create_list_menu($cur_list['list_menu'], 'top');

	if (isset($cur_list['additional_rows']['top_of_list']))
		template_cb_additional_rows('top_of_list', $cur_list);

	if (isset($cur_list['additional_rows']['after_title']))
		template_cb_additional_rows('after_title', $cur_list);

	// Show the page index (if this list doesn't intend to show all items).
	if (!empty($cur_list['items_per_page']))
	{
		echo '
			<tr class="catbg">
				<td align="left" colspan="', $cur_list['num_columns'], '">
					<b>', $txt[139], ':</b> ', $cur_list['page_index'], '
				</td>
			</tr>';
	}

	if (isset($cur_list['additional_rows']['above_column_headers']))
		template_cb_additional_rows('above_column_headers', $cur_list);

	// Show the column headers.
	$header_count = count($cur_list['headers']);
	if (0 < $header_count)
	{
		echo '
			<tr class="titlebg">';

		// Loop through each column and add a table header.
		foreach ($cur_list['headers'] as $col_header)
		{
			echo '
				<td valign="top"', empty($col_header['class']) ? '' : ' class="' . $col_header['class'] . '"', empty($col_header['style']) ? '' : ' style="' . $col_header['style'] . '"', empty($col_header['colspan']) ? '' : ' colspan="' . $col_header['colspan'] . '"', '>',
					empty($col_header['href']) ? '' : '<a href="' . $col_header['href'] . '">',
					empty($col_header['label']) ? '&nbsp;' : $col_header['label'],
					empty($col_header['sort_image']) ? '' : ' <img src="' . $settings['images_url'] . '/sort_' . $col_header['sort_image'] . '.gif" alt="" />',
					empty($col_header['href']) ? '' : '</a>',
				'</td>';
		}

		echo '
			</tr>';
	}

	// Show a nice message informing there are no items in this list.
	if (empty($cur_list['rows']) && !empty($cur_list['no_items_label']))
	{
		echo '
			<tr>
				<td class="windowbg" colspan="', $cur_list['num_columns'], '" align="', !empty($cur_list['no_items_align']) ? $cur_list['no_items_align'] : 'center', '">', $cur_list['no_items_label'], '</td>
			</tr>';
	}

	// Show the list rows.
	elseif (!empty($cur_list['rows']))
	{
		$alternate = false;
		foreach ($cur_list['rows'] as $id => $row)
		{
			echo '
			<tr class="windowbg', $alternate ? '2' : '', '">';

			foreach ($row as $row_data)
				echo '
				<td', empty($row_data['class']) ? '' : ' class="' . $row_data['class'] . '"', empty($row_data['style']) ? '' : ' style="' . $row_data['style'] . '"', '>', $row_data['value'], '</td>';

			echo '
			</tr>';

			$alternate = !$alternate;
		}
	}

	// Show the page index (if this list doesn't intend to show all items).
	if (!empty($cur_list['items_per_page']))
	{
		echo '
			<tr class="catbg">
				<td align="left" colspan="', $cur_list['num_columns'], '">
					<b>', $txt[139], ':</b> ', $cur_list['page_index'], '
				</td>
			</tr>';
	}

	if (isset($cur_list['additional_rows']['below_table_data']))
		template_cb_additional_rows('below_table_data', $cur_list);

	if (isset($cur_list['additional_rows']['bottom_of_list']))
		template_cb_additional_rows('bottom_of_list', $cur_list);

	echo '
		</table>';

	if (isset($cur_list['form']))
	{
		foreach ($cur_list['form']['hidden_fields'] as $name => $value)
			echo '
		<input type="hidden" name="', $name, '" value="', $value, '" />';

		echo '
	</form>';
	}

	// Tabs at the bottom. Usually bottom aligned.
	if (!empty($settings['use_tabs']) && isset($cur_list['list_menu'], $cur_list['list_menu']['show_on']) && ($cur_list['list_menu']['show_on'] == 'both' || $cur_list['list_menu']['show_on'] == 'bottom'))
		template_cb_create_list_menu($cur_list['list_menu'], 'bottom');

	if (isset($cur_list['javascript']))
	{
		echo '
	<script language="JavaScript" type="text/javascript"><!-- // --><![CDATA[
		', $cur_list['javascript'], '
	// ]]></script>';
	}
}

// Shows additional rows.
// Supported row positions: top_of_list, after_title,
// above_column_headers, below_table_data, bottom_of_list.
function template_cb_additional_rows($row_position, $cur_list)
{
	$class = 'after_title' == $row_position ? 'windowbg': 'windowbg2';
	$style = in_array($row_position, array('above_column_headers', 'below_table_data', 'bottom_of_list')) ? 'text-align: right;' : '';
	foreach ($cur_list['additional_rows'][$row_position] as $row)
	{
		echo '
		<tr class="', $class, empty($row['class']) ? '' : ' ' . $row['class'], '"', !empty($style) ? ' style="' . $style . '"' : '', '>
			<td colspan="', $cur_list['num_columns'], '"', empty($row['style']) ? '' : ' style="' . $row['style'] . '"', '>
				', $row['value'], '
			</td>
		</tr>';
	}
}

// Shows list menu.
function template_cb_create_list_menu($list_menu, $direction = 'top')
{
	global $settings;

	/*
		// This is use if you want your generic lists to have tabs.
		$list_menu = array(
			// This is used by the old styled menu.  We *need* to know the total number of columns to span.
			'columns' => 0,
			// This gives you the option to show tabs only at the top, bottom or both.
			// By default they are just shown at the top.
			'show_on' => 'top',
			// Links.  This is the core of the array.  It has all the info that we need.
			'links' => array(
				'name' => array(
					// This will tell use were to go when they click it.
					'href' => $scripturl . '?action=theaction',
					// The name that you want to appear for the link.
					'label' => $txt['name'],
					// If we use tabs instead of buttons we highlight the current tab.
					// Must use conditions to determine if its selected or not.
					'is_selected' => isset($_REQUEST['name']),
				),
			),
		);
	*/

	if (!empty($settings['use_tabs'])) // {'top', 'bottom'} == $direction
	{
		$class_prefix = 'bottom' == $direction ? 'main' : 'mirror';
		echo '
	<table cellpadding="0" cellspacing="0" border="0" style="margin-left: 10px;">
		<tr>
			<td class="', $class_prefix, 'tab_first">&nbsp;</td>';

		foreach ($list_menu['links'] as $link)
		{
			if ($link['selected'])
			{
				echo '
				<td class="', $class_prefix, 'tab_active_first">&nbsp;</td>
				<td valign="top" class="', $class_prefix, 'tab_active_back">
					<a href="', $link['href'], '">', $link['label'], '</a>
				</td>
				<td class="', $class_prefix, 'tab_active_last">&nbsp;</td>';
			}
			else
			{
				echo '
				<td valign="top" class="', $class_prefix, 'tab_back">
					<a href="', $link['href'], '">', $link['label'], '</a>
				</td>';
			}
		}

		echo '
			<td class="', $class_prefix, 'tab_last">&nbsp;</td>
		</tr>
	</table>';
	}
	else // 'top' == $direction
	{
		$links = array();
		foreach ($list_menu['links'] as $link)
			$links[] = ($link['selected'] ? '<img src="' . $settings['images_url'] . '/selected.gif" alt="&gt;" /> ' : '') . '<a href="' . $link['href'] . '">' . $link['label'] . '</a>';

		echo '
		<tr class="titlebg">
			<td colspan="', $list_menu['columns'], '">
				', implode(' | ', $links), '
			</td>
		</tr>';
	}
}

?>