<?php

/**
 * Custom blocks
 *
 * @package CustomBlocks
 * @version 2.1
 * @author davidhs
 * @copyright 2013 by davidhs
 * @license Creative Commons Attribution 3.0 Unported License http://creativecommons.org/licenses/by/3.0/
 */

if (file_exists(dirname(__FILE__) . '/SSI.php') && !defined('SMF'))
	require_once (dirname(__FILE__) . '/SSI.php');
elseif (!defined('SMF'))
	exit('<b>Error:</b> Cannot install - please verify you put this in the same place as SMF\'s index.php.');

if (empty($context['uninstalling']))
{
	// Upgrade from 1.x to 2.0.
	if (!isset($modSettings['cb_header_ids']) && !isset($modSettings['cb_footer_ids']))
	{
		$trans_permissions = array(
			'all' => 'guest:view,user:view,mod:view,admin:view',
			'guest' => 'guest:view',
			'user' => 'user:view,mod:view,admin:view',
		);

		$setArray = array();
		$pos_array = array('header', 'footer');
		foreach ($pos_array as $pos)
		{
			$ids = array();
			if (!empty($modSettings['cb_' . $pos . '_number']))
			{
				for ($id0 = 0; $id0 < $modSettings['cb_' . $pos . '_number']; $id0++)
				{
					$id = $id0 + 1;
					$ids[] = $id;

					$pos_id0 = $pos . '_' . $id0;
					$pos_id = $pos . '_' . $id;

					$setArray['cb_' . $pos_id . '_description'] = isset($modSettings['cb_' . $pos_id0 . '_name']) ? $smcFunc['htmlspecialchars']($modSettings['cb_' . $pos_id0 . '_name'], ENT_QUOTES) : '';
					$setArray['cb_' . $pos_id . '_frame'] = '';
					$setArray['cb_' . $pos_id . '_type'] = !empty($modSettings['cb_' . $pos_id0 . '_type']) ? $modSettings['cb_' . $pos_id0 . '_type'] : 'html';
					$setArray['cb_' . $pos_id . '_content'] = isset($modSettings['cb_' . $pos_id0 . '_content']) ? $modSettings['cb_' . $pos_id0 . '_content'] : '';
					$setArray['cb_' . $pos_id . '_order'] = !empty($modSettings['cb_' . $pos_id0 . '_order']) ? $modSettings['cb_' . $pos_id0 . '_order'] : '0';
					$setArray['cb_' . $pos_id . '_permissions'] = !empty($modSettings['cb_' . $pos_id0 . '_permissions']) ? $trans_permissions[$modSettings['cb_' . $pos_id0 . '_permissions']] : $trans_permissions['all'];
				}
			}
			$setArray['cb_' . $pos . '_ids'] = implode(',', $ids);
		}

		$replaceArray = array();
		foreach ($setArray as $variable => $value)
			$replaceArray[] = array($variable, $value);

		$smcFunc['db_insert']('replace',
			'{db_prefix}settings',
			array('variable' => 'string-255', 'value' => 'string-65534'),
			$replaceArray,
			array('variable')
		);

		$smcFunc['db_query']('', '
			DELETE FROM {db_prefix}settings
			WHERE variable LIKE {string:filter1}
				OR variable LIKE {string:filter2}
				OR variable LIKE {string:filter3}',
			array(
				'filter1' => 'cb\\_%\\_number',
				'filter2' => 'cb\\_%\\_0\\_%',
				'filter3' => 'cb\\_%\\_name',
			)
		);

		// Kill the cache - it needs redoing now, but we won't bother ourselves with that here.
		cache_put_data('modSettings', null, 90);
	}

	// Upgrade from 2.0.x to 2.1.
	if (!isset($modSettings['cb_header_above_ids']))
	{
		$pos_array = array('header', 'footer');
		$pos_ids = array();
		foreach ($pos_array as $pos)
		{
			if (!empty($modSettings['cb_' . $pos . '_ids']))
			{
				$ids = explode(',', $modSettings['cb_' . $pos . '_ids']);
				foreach ($ids as $id)
					$pos_ids[] = $pos . '_' . $id;
			}
		}

		$setArray = array();
		foreach ($pos_ids as $pos_id)
			$setArray['cb_' . $pos_id . '_active'] = '1';
		$setArray['cb_header_above_ids'] = '';
		$setArray['cb_header_below_ids'] = '';
		$setArray['cb_footer_above_ids'] = '';
		$setArray['cb_footer_below_ids'] = '';

		$replaceArray = array();
		foreach ($setArray as $variable => $value)
			$replaceArray[] = array($variable, $value);

		$smcFunc['db_insert']('replace',
			'{db_prefix}settings',
			array('variable' => 'string-255', 'value' => 'string-65534'),
			$replaceArray,
			array('variable')
		);

		// Kill the cache - it needs redoing now, but we won't bother ourselves with that here.
		cache_put_data('modSettings', null, 90);
	}
}

?>